BZOJ4872:[SHOI2017]分手是祝愿——题解

BZOJ4872:[SHOI2017]分手是祝愿——题解

大家好,又见面了,我是全栈君。

http://www.lydsy.com/JudgeOnline/problem.php?id=4872

https://www.luogu.org/problemnew/show/P3750

Zeit und Raum trennen dich und mich.

时空将你我分开。

B 君在玩一个游戏,这个游戏由 n 个灯和 n 个开关组成,给定这 n 个灯的初始状态,下标为从 1 到 n 的正整数。

每个灯有两个状态亮和灭,我们用 1 来表示这个灯是亮的,用 0 表示这个灯是灭的,游戏的目标是使所有灯都灭掉。

但是当操作第 i 个开关时,所有编号为 i 的约数(包括 1 和 i)的灯的状态都会被改变,即从亮变成灭,或者是从灭变成亮。

B 君发现这个游戏很难,于是想到了这样的一个策略,每次等概率随机操作一个开关,直到所有灯都灭掉。

这个策略需要的操作次数很多, B 君想到这样的一个优化。如果当前局面,可以通过操作小于等于 k 个开关使所有灯都灭掉,那么他将不再随机,直接选择操作次数最小的操作方法(这个策略显然小于等于 k 步)操作这些开关。

B 君想知道按照这个策略(也就是先随机操作,最后小于等于 k 步,使用操作次数最小的操作方法)的操作次数的期望。

这个期望可能很大,但是 B 君发现这个期望乘以 n 的阶乘一定是整数,所以他只需要知道这个整数对 100003 取模之后的结果。

期望dp,首先显然我们可以预处理出所有数的约数。

然后考虑我们的最小策略:显然每个灯都得按,所以从大到小依次按灭就是最小步数。

如果这个步数大于k,设dp[i]表示当前还有i步到达结束状态,使其变成dp[i-1]态的概率(期望步数)。

那么显然按对的概率为i/n,按不对的概率为(n-i)/n,按对只需要1步,按不对需要最开始的1步+dp[i+1]+dp[i]。

所以答案为dp[i]=i/n+(n-i)/n*(1+dp[i+1]+dp[i])。

移项即可。

#include<algorithm>
#include<iostream>
#include<cstring>
#include<cctype>
#include<cstdio>
#include<vector>
#include<cmath>
using namespace std;
typedef long long ll;
const int p=100003;
const int N=1e5+5;
inline int read(){
    int X=0,w=0;char ch=0;
    while(!isdigit(ch)){w|=ch=='-';ch=getchar();}
    while(isdigit(ch))X=(X<<3)+(X<<1)+(ch^48),ch=getchar();
    return w?-X:X;
}
ll qpow(ll k,int n){
    ll ans=1;
    while(n){
    if(n&1)ans=ans*k%p;
    k=k*k%p;n>>=1;
    }
    return ans;
}
vector<int>v[N];
ll f[N];
int on[N];
int main(){
    int n=read(),k=read();
    for(int i=1;i<=n;i++){
    on[i]=read();
    for(int j=i;j<=n;j+=i)
        v[j].push_back(i);
    }
    ll tim=0,ans=0;
    for(int i=n;i>=1;i--){
    if(on[i]){
        for(int j=0;j<v[i].size();j++)on[v[i][j]]^=1;
        tim++;
    }
    }
    if(tim<=k)ans=tim;
    else{
    ans=k;
    f[n]=1;
    for(int i=n-1;i>=1;i--){
        f[i]=(n+(n-i)*f[i+1])%p*qpow(i,p-2)%p;
    }
    for(int i=tim;i>k;i--)ans=(ans+f[i])%p;
    }
    for(int i=1;i<=n;i++)ans=ans*i%p;
    printf("%lld\n",ans);
    return 0;
}

+++++++++++++++++++++++++++++++++++++++++++

 +本文作者:luyouqi233。               +

 +欢迎访问我的博客:http://www.cnblogs.com/luyouqi233/+

+++++++++++++++++++++++++++++++++++++++++++

转载于:https://www.cnblogs.com/luyouqi233/p/8459165.html

版权声明:本文内容由互联网用户自发贡献,该文观点仅代表作者本人。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。如发现本站有涉嫌侵权/违法违规的内容, 请发送邮件至 举报,一经查实,本站将立刻删除。

发布者:全栈程序员-站长,转载请注明出处:https://javaforall.net/107701.html原文链接:https://javaforall.net

赞 (0)
全栈程序员-站长的头像全栈程序员-站长


相关推荐

  • pycharm安装pandas「建议收藏」

    pycharm安装pandas「建议收藏」在控制台输入pipinstallpandas后出现Requirementalreadysatisfied之后按照下面的步骤安装就可以了。安装完成后importpandas就不会报错了。

    2022年8月25日
  • pycharm中格式化快捷键是什么_pycharm快捷键大全

    pycharm中格式化快捷键是什么_pycharm快捷键大全(1)快捷键:Ctrl+Alt+L可以将代码格式工整化(2)鼠标点击

    2022年10月27日
  • 温度传感器 JUMO芯片铂电阻各型号优点

    温度传感器JUMO芯片铂电阻德国久茂Jumo品牌介绍:德国JUMOGmbH&KG公司成立于1948年,位于德国中部城市Fulda。公司经过六十多年的发展,已经成为欧洲著名的仪表制造厂商,公司主要致力于生产高质量的传感器、变送器及控制器,可提供工业温度、压力、湿度、液位、流量、pH值、电导率、氧化还原值的测量、控制及记录产品。坦泼秋尔(TPQE):德国久茂Jumo中国区唯…

    2022年4月6日
  • 回溯法之01背包问题

    回溯法之01背包问题一、问题n皇后问题的解空间树是一颗排列树,而01背包问题的解空间树应该是一颗子集树。再简述下该问题:有n件物品和一个容量为c的背包。第i件物品的价值是v[i],重量是w[i]。求解将哪些物品装入背包可使价值总和最大。所谓01背包,表示每一个物品看成一个整体,要么全部装入,要么都不装入。这里n=5,c=10,w={2,2,6,5,4},v={6,3,5,4,6}。01背…

    2022年10月17日
  • java 设置随机数种子_java随机数种子怎么设置[通俗易懂]

    java 设置随机数种子_java随机数种子怎么设置[通俗易懂]java随机数种子怎么设置引导语:Java技术具有卓越的通用性、高效性、平台移植性和安全性,广泛应用于PC、数据中心、游戏控制台、科学超级计算机、移动电话和互联网,同时拥有全球最大的开发者专业社群。以下是小编整理的java随机数种子怎么设置,欢迎参考阅读!java设置随机数种子教程:一、在j2se里我们可以使用Math.random()方法来产生一个随机数,这个产生的随机数是0-1之间的一个dou…

    2022年7月14日
  • python 匹配文本全角转半角字符「建议收藏」

    python 匹配文本全角转半角字符「建议收藏」在对文本进行处理的时候经常会遇见要对括号和标点进行匹配常见的英文(半角)符号如()直接用正则匹配即可但是遇见全角字符(中文括号、标点),直接用正则匹配会存在问题:因为编码通常为为utf8,若直接匹配,中文括号的3字节编码会和一些中文的字节编码重复,产生意想不到的结果若用decode转为unicode编码,则可避免产生错误结果,但也无法直接用正则匹配到经过试验,发现一个看上去

    2022年7月15日

发表回复

您的邮箱地址不会被公开。 必填项已用 * 标注

关注全栈程序员社区公众号